/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesGoogleAnalytics4StaticApiService ServicesGoogleAnalytics4StaticApi service
type ServicesGoogleAnalytics4StaticApiService service

type ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest struct {
	ctx                                                                           context.Context
	ApiService                                                                    *ServicesGoogleAnalytics4StaticApiService
	appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
}

//
func (r ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest(appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	r.appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest = &appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
	return r
}

func (r ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) Execute() (*GoogleAnalytics4StaticUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewExecute(r)
}

/*
AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNew Authorize a service

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
*/
func (a *ServicesGoogleAnalytics4StaticApiService) AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNew(ctx context.Context) ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	return ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return GoogleAnalytics4StaticUserAuth
func (a *ServicesGoogleAnalytics4StaticApiService) AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewExecute(r ApiAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) (*GoogleAnalytics4StaticUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *GoogleAnalytics4StaticUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesGoogleAnalytics4StaticApiService.AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNew")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/google_analytics4_static"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
